%global momorel 2

Summary: System wide profiler
Name: oprofile
Version: 0.9.6
Release: %{momorel}m%{?dist}
License: GPLv2
Group: Development/System
Source0: http://dl.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz 
NoSource: 0
Requires: binutils >= 2.17.50.0.8-2
Requires: which
Requires(pre): shadow-utils
Patch10: oprofile-0.4-guess2.patch
Patch63: oprofile-0.7-libs.patch
# momonga's patches
Patch101: oprofile-0.9.4-testsuite.patch
URL: http://oprofile.sf.net/

ExclusiveArch: %{ix86} ia64 x86_64 ppc ppc64 s390 s390x alpha alphaev6 sparcv9 sparc64
BuildRequires: qt3-devel
BuildRequires: libxslt
BuildRequires: docbook-style-xsl
BuildRequires: docbook-utils
BuildRequires: elinks
BuildRequires: gtk2-devel
BuildRequires: automake
BuildRequires: binutils-devel >= 2.17.50.0.3-3m
BuildRequires: binutils-static
BuildRequires: zlib-devel
BuildRequires: popt-devel
BuildRequires: libtool
BuildRequires: java-1.6.0-openjdk-devel, jpackage-utils
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

### include local configuration
%{?include_specopt}
### default configurations
#  If you'd like to change these configurations, please copy them to
# ~/rpmbuild/specopt/oprofile.specopt and edit it.
%{?!do_test: %global do_test 0}

%description
OProfile is a profiling system for systems running Linux. The
profiling runs transparently during the background, and profile data
can be collected at any time. OProfile makes use of the hardware performance
counters provided on Intel P6, and AMD Athlon family processors, and can use
the RTC for profiling on other x86 processor types.

See the HTML documentation for further details.

%package devel
Summary: Header files and libraries for developing apps which will use oprofile.
Group: Development/Libraries
Requires: oprofile = %{version}-%{release}

%description devel

Header files and libraries for developing apps which will use oprofile.

%package gui
Summary: GUI for oprofile.
Group: Development/System
Requires: oprofile = %{version}-%{release}

%description gui

The oprof_start GUI for oprofile.

%package jit
Summary: Libraries required for profiling Java and other JITed code
Group: Development/System
Requires: oprofile = %{version}-%{release}

%description jit
This package includes a base JIT support library, as well as a Java
agent library.

%prep
%setup -q -n %{name}-%{version}
%patch10 -p1 -b .guess2
%patch63 -p1 -b .libs

%if %{do_test}
%patch101 -p1 -b .test~
%endif
./autogen.sh

%build
QTDIR=%{_libdir}/qt3;     export QTDIR

#The CXXFLAGS below is temporary to work around
# bugzilla #113909
CXXFLAGS=-g;     export CXXFLAGS

# binutils requires zlib
export LDFLAGS=-lz
%configure \
	   --with-kernel-support \
	   --enable-abi \
	   --with-qt-dir=$QTDIR \
	   --with-java=/usr/lib/jvm/java
%make

%if %{do_test}
%check
make check
%endif

%install
rm -rf --preserve-root %{buildroot}

make install DESTDIR=%{buildroot}

# We build it in place and then move it away so it doesn't get installed
# twice. rpm can specify itself where the (versioned) docs go with the
# %doc directive.
mkdir docs.installed
mv %{buildroot}%{_datadir}/doc/oprofile/* docs.installed/

#hack to make header files available
mkdir -p %{buildroot}%{_includedir}
install -m 755 libop/op_events.h %{buildroot}/%{_includedir}
install -m 755 libop/op_cpu_type.h %{buildroot}/%{_includedir}
#install -m 755 libop/op_events_desc.h %{buildroot}/%{_includedir}
install -m 755 libop/op_config.h %{buildroot}/%{_includedir}
install -m 755 libop/op_sample_file.h %{buildroot}/%{_includedir}
install -m 755 libutil/op_types.h %{buildroot}/%{_includedir}
install -m 755 libutil/op_list.h %{buildroot}/%{_includedir}
install -m 755 libdb/odb.h %{buildroot}/%{_includedir}

#hack to make .a files available
mkdir -p %{buildroot}%{_libdir}
install -m 755 libop/libop.a %{buildroot}/%{_libdir}
install -m 755 libdb/libodb.a %{buildroot}/%{_libdir}
install -m 755 libutil/liboputil.a %{buildroot}/%{_libdir}
install -m 755 libutil++/liboputil++.a %{buildroot}/%{_libdir}
#install -m 755 pp/liboppp.a %{buildroot}/%{_libdir}
install -m 755 libabi/libopabi.a %{buildroot}/%{_libdir}

mkdir -p %{buildroot}/etc/ld.so.conf.d
echo "%{_libdir}/oprofile" > %{buildroot}/etc/ld.so.conf.d/oprofile-%{_arch}.conf

%clean
rm -rf --preserve-root %{buildroot}

%pre
getent group oprofile >/dev/null || groupadd -r oprofile
getent passwd oprofile >/dev/null || \
useradd -r -g oprofile -d /home/oprofile -r -u 16 -s /sbin/nologin \
 -c "Special user account to be used by OProfile" oprofile
exit 0

%files
%defattr(-,root,root)
%doc  docs.installed/*
%doc COPYING

%{_bindir}/ophelp
%{_bindir}/opimport
%{_bindir}/opannotate
%{_bindir}/opcontrol
%{_bindir}/opgprof
%{_bindir}/opreport
%{_bindir}/oprofiled
%{_bindir}/oparchive
%{_bindir}/opjitconv

%{_mandir}/man1/ophelp.1*
%{_mandir}/man1/opannotate.1*
%{_mandir}/man1/opcontrol.1*
%{_mandir}/man1/opgprof.1*
%{_mandir}/man1/opreport.1*
%{_mandir}/man1/oprofile.1*
%{_mandir}/man1/oparchive.1*
%{_mandir}/man1/opimport.1*

%{_datadir}/oprofile

%files devel
%defattr(-,root,root)

%{_includedir}/odb.h
%{_includedir}/op_config.h
%{_includedir}/op_cpu_type.h
%{_includedir}/op_events.h
%{_includedir}/op_list.h
%{_includedir}/op_sample_file.h
%{_includedir}/op_types.h
%{_includedir}/opagent.h

%{_libdir}/libodb.a
%{_libdir}/libop.a
%{_libdir}/libopabi.a
%{_libdir}/liboputil++.a
%{_libdir}/liboputil.a

%files gui
%defattr(-,root,root)

%{_bindir}/oprof_start

%post jit -p /sbin/ldconfig

%postun jit -p /sbin/ldconfig

%files jit
%defattr(-,root,root)

%{_libdir}/oprofile
/etc/ld.so.conf.d/*

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.9.6-2m)
- full rebuild for mo7 release

* Sun May 16 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.6-1m)
- update to 0.9.6

* Mon May  3 2010 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.5-4m)
- add "BuildRequires: binutils-static"

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.5-3m)
- rebuild against gcc-4.4 and glibc-2.11

* Fri Oct  2 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.5-2m)
- remove excess Requires

* Sun Sep  6 2009 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.5-1m)
- update to 0.9.5

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.4-3m)
- rebuild against rpm-4.6

* Wed Oct 22 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.4-2m)
- add LDFLAGS=-lz for binutils-2.18.50.0.9

* Fri Jul 25 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.4-1m)
- update 0.9.4
- update gcc43 and testsuite patch
- sync with fc-devel (oprofile-0_9_4-2_fc10)
-- add java support

* Thu May  8 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.3-6m)
- rebuild against qt3

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.9.3-5m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (0.9.3-4m)
- %%NoSource -> NoSource

* Fri Jan 25 2008 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.3-3m)
- sync with fc-devel (oprofile-0_9_3-15_fc9)
-- fixed rhbz #250852, #394571, #391251, #232956 and #23400.

* Mon Nov 26 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.3-2m)
- added a patch for gcc43
- added %%check section

* Wed Aug 15 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.3-1m)
- update to 0.9.3
- sync with fc-devel (oprofile-0_9_3-2_fc8)
--* Tue Jul 25 2007 Will Cohen <wcohen@redhat.com> - 0.9.3-2
--- Re-enable xen patch.
--* Tue Jul 17 2007 Will Cohen <wcohen@redhat.com> - 0.9.3-1
--- Rebase on 0.9.3 release.
--- Disable xen patch until fixed.
--* Mon May 21 2007 Will Cohen <wcohen@redhat.com> - 0.9.2-9
--- Fix up rpmlint complaints.
--* Wed Mar 21 2007 Will Cohen <wcohen@redhat.com> - 0.9.2-8
--- Add AMD family 10 support. Resolves: rhbz#232956.

* Thu Mar 22 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.2-4m)
- sync with fc-devel (oprofile-0_9_2-7_fc7)
--* Wed Mar 21 2007 Will Cohen <wcohen@redhat.com> - 0.9.2-7
--- Correct description for package.
--- Correct backtrace documentation. Resolves: rhbz#214793.
--- Correct race condition. Resolves: rhbz#220116.

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.9.2-3m)
- rebuild against binutils-2.17.50.0.8

* Sat Oct  7 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (0.9.2-2m)
- rebuild against binutils-2.17.50.0.3-3m

* Sat Sep 23 2006 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- import from fc-devel (0.9.2-2)
